#pragma config(Sensor, S1,     leftSonar,      sensorEV3_Ultrasonic)
#pragma config(Sensor, S2,     rightColor,      sensorEV3_Color)
#pragma config(Sensor, S4,     rightSonar,     sensorEV3_Ultrasonic)
#pragma config(Motor,  motorA,          ruleMotor,     tmotorEV3_Large, openLoop, encoder)
#pragma config(Motor,  motorB,          speedMotor,    tmotorEV3_Large, openLoop, encoder)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

int e, alpha, alphaNew=0, state=0, lastState=0;
int per=0, v=70, center=0, rightGrey=0, rightWhite=0, rightBlack=0, colorParket=0;
const int kAlpha=7, t=1000;
const float kRule=1;

void calibr()
{
	/*
	displayCenteredBigTextLine(3, "Put the right");
	displayCenteredBigTextLine(5, "color sensor on");
	displayCenteredBigTextLine(7, "parket and press");
	displayCenteredBigTextLine(9, "the left button");
	while(!getButtonPress(buttonLeft))
		sleep(1);
	colorParket=SensorValue[rightColor];
	playSound(soundBeepBeep);
	*/
	displayCenteredBigTextLine(3, "Put the right");
	displayCenteredBigTextLine(5, "color sensor on");
	displayCenteredBigTextLine(7, "white and press");
	displayCenteredBigTextLine(9, "the right button");
	while(!getButtonPress(buttonRight))
		sleep(1);
	rightWhite=SensorValue[rightColor];
	playSound(soundBeepBeep);

	displayCenteredBigTextLine(3, "Put the right");
	displayCenteredBigTextLine(5, "color sensor on");
	displayCenteredBigTextLine(7, "black and press,");
	displayCenteredBigTextLine(9, "the left button");
	while(!getButtonPress(buttonLeft))
		sleep(1);
	rightBlack=SensorValue[rightColor];
	playSound(soundBeepBeep);
	rightGrey=(rightWhite+rightBlack)/2;

	eraseDisplay();
	displayCenteredBigTextLine(5, "Press Enter");
	displayCenteredBigTextLine(7, "and wait for");
	displayCenteredBigTextLine(9, "the signal");
	while(!getButtonPress(buttonEnter))
		sleep(1);

	motor[ruleMotor]=-10;
	sleep(2000);
	motor[ruleMotor]=0;
	nMotorEncoder[ruleMotor]=0;

	motor[ruleMotor]=10;
	sleep(3000);
	motor[ruleMotor]=0;
	center=nMotorEncoder[ruleMotor]/2;

	motor[ruleMotor]=-10;
	while(nMotorEncoder[ruleMotor]!=center)
		sleep(1);
	motor[ruleMotor]=0;
	playSound(soundBeepBeep);
}

task moveRobot()
{
	while(true)
	{
		e=SensorValue[rightSonar]-SensorValue[leftSonar];
		if (abs(e)>100)
			alpha=center+sgn(e)*center;
		else
			alpha=center+e/2;

		alphaNew+=sgn(alpha-alphaNew)*kAlpha;

		motor[ruleMotor]=(alphaNew-nMotorEncoder[ruleMotor])*kRule;
		motor[speedMotor]=v;
		sleep(50);
	}
}

void stopLine()
{
	eraseDisplay();
	displayCenteredBigTextLine(9, "Stop Line");
	sleep(1500);

	stopTask(moveRobot);
	motor[speedMotor]=0;
	motor[ruleMotor]=0;
	sleep(1000);
	startTask(moveRobot);
	sleep(1500);
}
/*
void rocks()
{
	eraseDisplay();
	displayCenteredBigTextLine(9, "Rocks");

	sleep(2000);

	motor[speedMotor]=v/2;
	sleep(1000);
	motor[speedMotor]=v;

}

void lines()
{
	eraseDisplay();
	displayCenteredBigTextLine(7, "Lines");
	sleep(2000);

	while(SensorValue[leftColor]>leftGrey)
	sleep(1);

	while(SensorValue[leftColor]<white)
	{
	e=SensorValue[leftColor]-leftGrey;
	alpha=center+e;
	alphaNew+=sgn(alpha-alphaNew)*kAlpha;

	motor[ruleMotor]=(alphaNew-nMotorEncoder[ruleMotor])*kRule;
	motor[speedMotor]=v/2;
	sleep(50);
	}

}*/

void perekr()
{
	if(SensorValue[rightColor]<rightBlack+2)
		state=1;
	else
		state=0;
	if(state==1 && state!=lastState)
	{
		per++;
		clearTimer(T1);
	}

	lastState=state;
	eraseDisplay();
	displayCenteredBigTextLine(1, "LeftSonar=%d", SensorValue[leftSonar]);
	displayCenteredBigTextLine(3, "RightSonar=%d", SensorValue[rightSonar]);
	displayCenteredBigTextLine(5, "rightColor=%d", SensorValue[rightColor]);
	displayCenteredBigTextLine(7, "per=%d", per);
	displayCenteredBigTextLine(9, "center=%d", center);
	sleep(1);
}

int readLines()
{
	per=0;
	v=v*2;
	while(per<3)
		perekr();

	v=v/2;
	while(time1(T1)<t)
		perekr();

	if(per==4)
		return 2;
	else if(per==5)
		return 3;
	else if(per==6)
		return 1;
	else
		return 0;
}

task main()
{
	calibr();
	displayCenteredBigTextLine(5, "Put the robot");
	displayCenteredBigTextLine(7, "on the track");
	displayCenteredBigTextLine(9, "and press Enter");
	while(!getButtonPress(buttonEnter))
		sleep(1);

	startTask(moveRobot);

	while(true)
	{
		switch(readLines())
		{
		case 0:
			break;

		case 1:
			stopLine();
			break;

		case 2:
			stopLine();
			break;

		case 3:
			stopLine();
			break;

		default:
			break;
		}
	}
}
